var Spamex_Service = {
	//PB     : Components.classes['@mozilla.org/preferences;1'].getService(Components.interfaces.nsIPrefBranch),
  prefs: null,
  secureProtocolFlag: false,
  popupWidth: 516,
  popupHeight: 360,
  username: null,
  password: null,
  // initialize the extension
  startup: function() {
    this.prefs = Components.classes["@mozilla.org/preferences-service;1"]
         .getService(Components.interfaces.nsIPrefService)
         .getBranch("spamex.");
    this.prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
    this.prefs.addObserver( "", this, false);

    if ( this.prefs.prefHasUserValue( "secureProtocolFlag" ) ) {
      this.secureProtocolFlag = this.prefs.getBoolPref( "secureProtocolFlag" );
    }
    if ( this.prefs.prefHasUserValue( "popupWidth" ) ) {
      this.popupWidth = this.prefs.getIntPref( "popupWidth" );
    }
    if ( this.prefs.prefHasUserValue( "popupHeight" ) ) {
      this.popupHeight = this.prefs.getIntPref( "popupHeight" );
    }
    if ( this.prefs.prefHasUserValue( "username" ) ) {
      this.username = this.prefs.getCharPref( "username" );
    }
    if ( this.prefs.prefHasUserValue( "password" ) ) {
      this.password = this.prefs.getCharPref( "password" );
    }
    
    try
    {
      if (document.getElementById("SpamexBar")) {
        return;
      }
    
      var navbar = document.getElementById("nav-bar");
      if (Spamex_Common.getBoolPref("firstrun", true) == true && navbar.currentSet.indexOf("SpamexBar") == -1)
      {
        var currentset = navbar.currentSet; 
        var hPos = currentset.indexOf("home-button");
        if (hPos != -1)
        {
          currentset = currentset.substr(0,hPos +11) + ",SpamexBar" + currentset.substr(hPos+11);
        }
        else 
        {
          hPos = currentset.indexOf("urlbar-container");
          if (hPos != -1)
          {
            currentset = currentset.substr(0,hPos +16) + ",SpamexBar" + currentset.substr(hPos+16);
          }
          else
            currentset=currentset + ",SpamexBar"; 
        }
        
        navbar.setAttribute("currentset",currentset);   //not needed I suppose 
        navbar.currentSet = currentset; 
        document.persist("nav-bar","currentset"); 
        Spamex_Common.setBoolPref("firstrun", false);
        setTimeout("try {     BrowserToolboxCustomizeDone(true);   } catch (e) {Spamex_DumpObj(e);}", 200);
      }
    }
    catch(ex)
    {
    }
  },
  shutdown: function() {
    this.prefs.removeObserver( "", this );
  },
  observe: function( subject, topic, prefName ) {
    if ( topic != "nsPref:changed" ) {
      return;
    }
    switch ( prefName ) {
      case "secureProtocolFlag":
        this.secureProtocolFlag = this.prefs.getBoolPref( "secureProtocolFlag" );
        break;
      case "popupWidth":
        this.popupWidth = this.prefs.getIntPref( "popupWidth" );
        break;
      case "popupHeight":
        this.popupHeight = this.prefs.getIntPref( "popupHeight" );
        break;
      case "username":
        this.username = this.prefs.getCharPref( "username" );
        break;
      case "password":
        this.password = this.prefs.getCharPref( "password" );
        break;
    }
  },
};


var Spamex_Common = {

	getFocusedWindow : function()
	{
		var myWindow = document.commandDispatcher.focusedWindow;
		if ( !myWindow || myWindow == window ) myWindow = window._content;
		return myWindow;
	},

	setBoolPref: function (aName, aValue)
	{
		try {
			Spamex_Service.prefs.setBoolPref(aName, aValue);
		} catch(ex) {
		}
	},

	resolveURL : function(aBaseURL, aRelURL)
	{
		try {
			var aBaseURLObj = this.convertURLToObject(aBaseURL);
			return aBaseURLObj.resolve(aRelURL);
		} catch(ex) {
			return aRelURL;
		}
	},
	
	convertURLToObject : function(aURLString)
	{
		var aURL = Components.classes['@mozilla.org/network/standard-url;1'].createInstance(Components.interfaces.nsIURI);
		aURL.spec = aURLString; 
		return aURL;
	},

	getBoolPref : function(aName, aDefVal)
	{
		try {
			return Spamex_Service.prefs.getBoolPref(aName);
		} catch(ex) {
			return aDefVal;
		}
	}
}

function Spamex_DumpObj(aObj)
{
		try {
			dump("-> " + aObj + "\n");
		} catch(ex) {
			dump("XXXXXXXXXX ERROR XXXXXXXXXX\n" + ex + "\n");
		}
	
}
